#include <bits/stdc++.h>
using namespace std;
const long long INF = 1000000009;
const long long MOD = 1000000007;
typedef long long ll;
typedef pair<ll,ll> pll;
typedef vector<ll> vect;
typedef vector<pair<ll,ll>> vll;
ll t,n,m,ind1,ind2,row,x,q,p1,p2;
ll a[100007],p[20007];
set<ll> se;
map<ll,vect> mapl;
string s;
int main()
{ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
    cin >> n >> m;
    for(int i=1;i<=m;i++){
        cin >> p1 >> p2;
        mapl[p1].push_back(p2);
        mapl[p2].push_back(p1);
    }
    ll ans=0;
    for(int i=1;i<=n;i++){
        if(mapl[i].size()<2){
            ans=1;
            break;
        }
    }
    if(ans==1) cout << "NO" << endl;
    for(int i=1;i<=n;i++){
        cout << i << " ";
    }
    cout << 1 << endl;
}




